﻿Clear-Host
CLS
$StartFile 	= "E:\QVFixPrice\QVReload\WPSScripts\CopyXLS\FilesForExport.txt"  #Путь к файлу с файлами
#Remove-Item $Logfile
$global:LengthFiles = 0
$global:CopyFilesCounter = 0
$global:ArchivedLengthFiles = 0
$global:ArchivedFilesCounter = 0
$global:errors=@()

#функция копирования файлов
function SendingFile ($HomeDect, $ExportDect){
#	if (!(Test-Path $HomeDect))
#	{
#	$Error = "Error Copy  " + $HomeDect
#	LogWrite $Error}
	if ((Test-Path -Path $ExportDect) -ne $true)
		{
		Write-Host $HomeDect
		Copy-Item -Path $HomeDect -Destination $ExportDect -Force
		$global:CopyFilesCounter = $global:CopyFilesCounter + 1
		}
	else
		{
		if ((Dir $HomeDect).LastWriteTime -gt (Dir $ExportDect).LastWriteTime)
			{
			Write-Host $HomeDect
			Copy-Item -Path $HomeDect -Destination $ExportDect -Force
			$global:CopyFilesCounter++
			$global:LengthFiles = $global:LengthFiles + $File.Length /1mb
			}
		}
	
	}	

#Извлекаем используемые источники
$Qv 			=  New-Object -ComObject QlikTech.QlikView
$Doc 			= $Qv.OpenDoc("E:\QVFixPrice\QVReload\Extractors\SourceExtractor.qvw")
$Doc.Reload()
$Doc.Save()
$Qv.Quit()
sleep -Seconds 3

#Начинаем копирование файлов
$FileOfFiles = Get-Content -Path $StartFile
for ($i = 1; $i -lt $FileOfFiles.length; $i++)
	{
	$DestFile = $FileOfFiles[$i] -split " -> " 
	$log = $DestFile[0]
	SendingFile -HomeDect $DestFile[0] -ExportDect $DestFile[1]
	}
	
$global:CopyFilesCounter = $global:CopyFilesCounter - $global:errors.Count
$LengthFiles = [math]::round($global:LengthFiles,2)
$ArchivedLengthFiles = [math]::round($global:ArchivedLengthFiles,2)
$CopyLogStr = "Copied " + $global:CopyFilesCounter + " files, size: " + $LengthFiles + " Mb"
$ArchiveLogStr = "Archived " + $global:ArchivedFilesCounter + " files, size: " + $ArchivedLengthFiles + " Mb"
$EndLogFile = "Copying end at " + (Get-Date).ToString()